#include <mega32.h>
#include "enc28j60_register.h"

#ifndef ENC28J60_H
#define ENC28J60_H

/* ENC28J60 SPI INSTRUCTIONS */

#ifndef ENCMD_RCR
  #define ENCMD_RCR 0x0
#endif

#ifndef ENCMD_WCR
  #define ENCMD_WCR 0x40
#endif

#ifndef ENCMD_RBM
  #define ENCMD_RBM 0x3A
#endif

#ifndef ENCMD_WBM
  #define ENCMD_WBM 0x7A
#endif

#ifndef ENCMD_BFS
  #define ENCMD_BFS 0x80
#endif

#ifndef ENCMD_BFC
  #define ENCMD_BFC 0xA0
#endif

#ifndef ENCMD_SRC
  #define ENCMD_SRC 0xFF
#endif

#ifndef ENC_CSPORT
  #define ENC_CSPORT PORTB
#endif                    

#ifndef ENC_CSPIN
  #define ENC_CSPIN 4
#endif

/* Pin-Definitionen */               

#ifndef SPIF
  #define SPIF 7
#endif

void enc_start();

void enc_stop();
 
void enc_reset(void);

void enc_bfs(unsigned char reg, unsigned char data);

void enc_bfc(unsigned char reg, unsigned char data);

void enc_wcr(unsigned char reg, unsigned char data);

void enc_wbm(unsigned char *data, int len);

void enc_rbm(unsigned char *data, int len);

unsigned char enc_rcr(unsigned char reg, unsigned char method);

void enc_banksel(unsigned char bank);
#endif /* ENC28J60_H */