
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

void enc_start();

void enc_stop();

void enc_reset(void);

void enc_bfs(unsigned char reg, unsigned char data);

void enc_bfc(unsigned char reg, unsigned char data);

void enc_wcr(unsigned char reg, unsigned char data);

void enc_wbm(unsigned char *data, int len);

void enc_rbm(unsigned char *data, int len);

unsigned char enc_rcr(unsigned char reg, unsigned char method);

void enc_banksel(unsigned char bank);

void UART_Init( unsigned int baud );

void UART_Transmit( unsigned char data );

unsigned char UART_Receive( void );

void UART_Flush( void );

void ausgabe_uart(char zeichenkette[]);

void ausgabe_uart_single_char(char zeichen);

void enc_start() {
PORTB = (0<<4);
}

void enc_stop() {
PORTB = (1<<4);
}

void enc_reset(void){
enc_start();

SPDR = 0xFF;
while(!(SPSR & (1 << 7)));

enc_stop();
}

void enc_bfs(unsigned char reg, unsigned char data){
enc_start();

SPDR = 0x80|reg;
while(!(SPSR & (1 << 7)));

SPDR = data;
while(!(SPSR & (1 << 7)));

enc_stop();
}

void enc_bfc(unsigned char reg, unsigned char data){
enc_start();

SPDR = 0xA0|reg;
while(!(SPSR & (1 << 7)));

SPDR = data;
while(!(SPSR & (1 << 7)));

enc_stop();
}

void enc_wcr(unsigned char reg, unsigned char data){
enc_start();

SPDR = 0x40|reg;
while(!(SPSR & (1 << 7)));

SPDR = data;
while(!(SPSR & (1 << 7)));

enc_stop();
}

unsigned char enc_rcr(unsigned char reg, unsigned char method){
enc_start();

ausgabe_uart_single_char(0x0);
ausgabe_uart_single_char(reg);    
ausgabe_uart_single_char(0x0|reg);

SPDR = 0x0|reg;
delay_ms(2);  
while(!(SPSR & (1 << 7)));
delay_ms(2);

if(method) { 
SPDR = 0;
while(!(SPSR & (1 << 7)));
}

enc_stop();
delay_ms(2);

return(SPDR);
}

void enc_wbm(unsigned char *data, int len){
int i;

enc_start();

SPDR = 0x7A;
while(!(SPSR & (1 << 7)));

for(i=0; i < len ;i++) { 
SPDR = *data++;
while(!(SPSR & (1 << 7)));
}

enc_stop();
}

void enc_rbm(unsigned char *data, int len){
int i;

enc_start();

SPDR = 0x3A;
while(!(SPSR & (1 << 7)));

for(i=0; i < len ;i++) {
SPDR = 0; while(!(SPSR & (1 << 7)));
*data++ = SPDR;
}

enc_stop();
}

void enc_banksel(unsigned char bank){
static unsigned char lastbank=0xf;

enc_bfc(0x1F,0|1);
enc_bfs(0x1F,bank);
lastbank = bank;
}
