#ifndef ENC28J60_REGISTER_H
#define ENC28J60_REGISTER_H

/* GLOBAL REGISTER */

#ifndef EIE 
  #define EIE 0X1B
#endif

#ifndef EIR
  #define EIR 0x1C
#endif

#ifndef ESTAT 
  #define ESTAT 0x1D
#endif

#ifndef ECON2 
  #define ECON2 0x1E
#endif

#ifndef ECON1
  #define ECON1 0x1F
#endif    

/* GLOBAL REGISTER BITS */

#ifndef ECON1_BSEL1
  #define ECON1_BSEL1 1
#endif

#ifndef ECON1_BSEL0
  #define ECON1_BSEL0 0
#endif

/* BANK 0 */

#ifndef ERDPTL
  #define ERDPTL 0x00
#endif

#ifndef ERDPTH
  #define ERDPTH 0x01
#endif

#ifndef EWRPTL
  #define EWRPTL 0x02
#endif

#ifndef EWRPTH
  #define EWRPTH 0x03
#endif

#ifndef ETXSTL
  #define ETXSTL 0x04
#endif

#ifndef ETXSTH
  #define ETXSTH 0x05   
#endif

#ifndef ETXNDL
  #define ETXNDL 0x06
#endif

#ifndef ETXNDH
  #define ETXNDH 0x07
#endif

#ifndef ERXSTL
  #define ERXSTL 0x08
#endif

#ifndef ERXSTH 
  #define ERXSTH 0x09
#endif

#ifndef ERXNDL 
  #define ERXNDL 0x0A
#endif

#ifndef ERXNDH 
  #define ERXNDH 0x0B
#endif

#ifndef ERXRDPTL 
  #define ERXRDPTL 0x0C
#endif

#ifndef ERXRDPTH 
  #define ERXRDPTH 0x0D
#endif

#ifndef ERXWRPTL 
  #define ERXWRPTL 0x0E
#endif

#ifndef ERXWRPTH 
  #define ERXWRPTH 0x0F
#endif

#ifndef EDMASTL 
  #define EDMASTL 0x10
#endif

#ifndef EDMASTH 
  #define EDMASTH 0x11
#endif

#ifndef EDMANDL 
  #define EDMANDL 0x12
#endif

#ifndef EDMANDH 
  #define EDMANDH 0x13
#endif

#ifndef EDMADSTL 
  #define EDMADSTL 0x14
#endif

#ifndef EDMADSTH 
  #define EDMADSTH 0x15
#endif

#ifndef EDMACSL 
  #define EDMACSL 0x16
#endif

#ifndef EDMACSH 
  #define EDMACSH 0x17
#endif

/* BANK 2 */

#ifndef MACON1
  #define MACON1 0x00
#endif

#ifndef MACON2
  #define MACON2 0x01
#endif

#ifndef MACON3
  #define MACON3 0x02
#endif

#ifndef MACON4
  #define MACON4 0x03
#endif

#ifndef MABBIPG
  #define MABBIPG 0x04
#endif

#ifndef MAIPGL
  #define MAIPGL 0x06
#endif

#ifndef MAIPGH
  #define MAIPGH 0x07
#endif

#ifndef MACLCON1
  #define MACLCON1 0x08
#endif

#ifndef MACLCON2 
  #define MACLCON2 0x09
#endif

#ifndef MAMXFLL 
  #define MAMXFLL 0x0A
#endif

#ifndef MAMXFLH 
  #define MAMXFLH 0x0B
#endif

#ifndef MICMD 
  #define MICMD 0x12
#endif

#ifndef MIREGADR 
  #define MIREGADR 0x14
#endif

#ifndef MIWRL 
  #define MIWRL 0x16
#endif

#ifndef MIWRH 
  #define MIWRH 0x17
#endif

#ifndef MIRDL 
  #define MIRDL 0x18
#endif

#ifndef MIRDH 
  #define MIRDH 0x19
#endif

/* BANK 3 */

#ifndef MAADR5
  #define MAADR5 0x00
#endif

#ifndef MAADR6
  #define MAADR6 0x01
#endif

#ifndef MAADR3
  #define MAADR3 0x02
#endif

#ifndef MAADR4
  #define MAADR4 0x03
#endif

#ifndef MAADR1
  #define MAADR1 0x04
#endif

#ifndef MAADR2
  #define MAADR2 0x05   
#endif

#ifndef EBSTSD
  #define EBSTSD 0x06
#endif

#ifndef EBSTCON
  #define EBSTCON 0x07
#endif

#ifndef EBSTCSL
  #define EBSTCSL 0x08
#endif

#ifndef EBSTCSH 
  #define EBSTCSH 0x09
#endif

#ifndef MISTAT 
  #define MISTAT 0x0A
#endif

#ifndef EREVID 
  #define EREVID 0x12
#endif

#ifndef EFLOCON 
  #define EFLOCON 0x17
#endif

#ifndef EPAUSL 
  #define EPAUSL 0x18
#endif

#ifndef EPAUSH 
  #define EPAUSH 0x19
#endif

#endif /* ENC28J60_REGISTER_H */