#include "uart.h"

void UART_Init( unsigned int baud ) {
  /* Set baud rate */
  UBRRH = (unsigned char)(baud>>8);
  UBRRL = (unsigned char)baud;
  
  /* Enable receiver and transmitter */
  UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE);
  //UCSRB = (1<<RXEN)|(1<<TXEN);
  
  /* Set frame format: 8data, 2stop bit */
  //UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0); 
  
  /* Set frame format: 8data, 1stop bit */
  UCSRC = (1<<URSEL)|(3<<UCSZ0);
}

void UART_Transmit( unsigned char data ) {
  /* Wait for empty transmit buffer */
  while ( !( UCSRA & (1<<UDRE)) );
  /* Put data into buffer, sends the data */
  UDR = data;
}

unsigned char UART_Receive( void ) {
  /* Wait for data to be received */
  while ( !(UCSRA & (1<<RXC)) );
  /* Get and return received data from buffer */
  return UDR;
}

void UART_Flush( void ) {
  unsigned dummy;
  while ( UCSRA & (1<<RXC) ) dummy = UDR;
}

void ausgabe_uart(char zeichenkette[]) {
  int i = 0;
  
  while(zeichenkette[i]) {
    UART_Transmit(zeichenkette[i++]);
  }
  UART_Transmit(0x0);
}

void ausgabe_uart_single_char(unsigned char zeichen) {
  UART_Transmit(zeichen);
  UART_Transmit(0x00);
}